
#include <vector>
#include "TCanvas.h"
#include "TAxis.h"
#include "TH1.h"
#include <iomanip>
#include <iostream>
#include <fstream>

void plotter_stack_new() {
   
  // TCanvas *c1 = new TCanvas("c1","Canvas_1");
  
  TCanvas *can   =new TCanvas("plot","plot",700,800);
  gStyle->SetOptStat(0);
  gPad->SetLeftMargin(0.18);
  // gPad->SetLogy(1);
  can->SetTickx(1);
  can->SetTicky(1);
    
  TPad *pad1 = new TPad("pad1", "pad1", 0.00, 0.33, 1.00, 1.00);
  TPad *pad2 = new TPad("pad2", "pad2", 0.00, 0.00, 1.00, 0.33);
    
    // pad1->SetLogy();
    pad1->SetBottomMargin(0.00001);
    pad1->SetBorderMode(0);
    pad1->SetLeftMargin(0.14);
    pad1->SetTickx(1);
    pad1->SetTicky(1);
    pad2->SetTopMargin(0.00001);
    pad2->SetBottomMargin(0.4);
    pad2->SetBorderMode(0);
    pad2->SetLeftMargin(0.14);
    pad2->SetTickx(1);
    pad2->SetTicky(1);
    gStyle->SetOptTitle(kFALSE);
    pad1->Draw();
    pad2->Draw();
    pad1->cd();

  TFile *f1 = new TFile("histo_b2_mc15_iriomote.root");
  TFile *f2 = new TFile("histo_b2_data_iriomote.root");

  TH1F *h1; //MC signal   
  TH1F *h2; //MC bkg
  TH1F *h3; //MC kspipi 
  TH1F *h4; //MC comb
  // TH1F *h5; //

  TH1F *h6; //Data

  TH1F *h7 = new TH1F("h7","ratio",100, 0.14, 0.159);  //DeltaM
  // TH1F *h7 = new TH1F("h7","ratio",100,-6, 6.7);// gamma

  h1 = (TH1F*)f1->Get("DeltaM_sig");
  h2 = (TH1F*)f1->Get("DeltaM_bkg");
  h3 = (TH1F*)f1->Get("DeltaM_kspipi");
  // h4 = (TH1F*)f1->Get("mkk_mult");
  // h5 = (TH1F*)f1->Get("mkk_ds");
  h6 = (TH1F*)f2->Get("DeltaM");


  // h1 = (TH1F*)f1->Get("Log_min_signal");
  // h2 = (TH1F*)f1->Get("Log_min_bkg");
  // h3 = (TH1F*)f1->Get("Log_min_peaking");
  // h4 = (TH1F*)f2->Get("Log_min_non_peaking");
  // // // h5 = (TH1F*)f1->Get("md0pi_ds");
  // h6 = (TH1F*)f2->Get("Log_min_total");
  
  // //  h1 attributes
  h1->SetFillColor(kPink+1);
  h1->SetLineColor(kPink+1);
  h1->SetMarkerColor(kPink+1);
  h1->SetMinimum(1.);

  //  h2 attributes
  h2->SetFillColor(kGreen+1);
  h2->SetLineColor(kGreen+1);
  h2->SetMarkerColor(kGreen+1);
  h2->SetMinimum(1.);

  //h3 attributes
  h3->SetFillColor(kBlue+1);
  h3->SetLineColor(kBlue+1);
  h3->SetMarkerColor(kBlue+1);
  h3->SetMinimum(1.);

  // //h4 attributes
  // h4->SetFillColor(kCyan);
  // h4->SetLineColor(kCyan);
  // h2->SetMarkerStyle(20);
  // h4->SetMarkerColor(kCyan);
  // h4->SetMinimum(1.);

  // // h5 attributes
  // h5->SetFillColor(kRed);
  // h5->SetLineColor(kRed);
  // h5->SetMarkerColor(kRed);
  // h5->SetMinimum(1.);

  //h6 attributes
  h6->SetMarkerStyle(20);
  h6->SetMarkerSize(0.8);
  h6->SetLineColor(kBlack);
  h6->SetMinimum(1.);

  //  stack histogram
  THStack *hs = new THStack("hs","Stacked 1D histograms");
  // hs->SetMinimum(0.0);
   
   // hs->Add(h5);
   // hs->Add(h6);
   
  hs->Add(h1);
  hs->Add(h2); 
  hs->Draw("HIST E1 X0");
  // hs->Draw("HIST");

  TH1F *h = new TH1F(*((TH1F *)(hs->GetStack()->Last())));

  // Scale
  Double_t scale = (h->Integral())/(h6->Integral());
  h6->Scale(scale); 

  h3->Draw("sames");
  h1->Draw("sames");

  h6->Draw("sames");

  // h4->Draw("sames");
  // h5->Draw("sames");

  gPad->Update();

  hs->GetXaxis()->SetTitle("#Delta m [GeV/c^{2}]");
  hs->GetYaxis()->SetTitle("Candidates per 0.2 MeV/c^{2}");

  // hs->GetXaxis()->SetTitle("#gamma");
  // hs->GetYaxis()->SetTitle("Candidates per 0.127");

  hs->GetXaxis()->SetTitleSize(0.05);
  hs->GetYaxis()->SetTitleSize(0.05);
  hs->GetXaxis()->CenterTitle();
  hs->GetYaxis()->CenterTitle();
  

  TLegend *leg = new TLegend(0.62,0.62,0.76,0.84,NULL,"brNDC");
  leg->SetBorderSize(0);
  leg->SetTextAlign(12);
  leg->SetTextFont(42);
  leg->SetTextSize(0.03230543);
  leg->SetLineColor(1);
  leg->SetLineStyle(1);
  leg->SetLineWidth(1);
  leg->SetFillColor(0);
  leg->SetFillStyle(1001);
  leg->AddEntry(h1,"Simulation (Signal)","f");
  leg->AddEntry(h2,"Simulation (Total background)","f");
  leg->AddEntry(h3,"Simulation (Kspipi bkg)","f");
  // leg->AddEntry(h4,"Simulation (Non-peaking bkg)","f");
  // leg->AddEntry(h5 ,"Simulation (Ds bkg)","f");
  leg->AddEntry(h6,"Data","P");
  leg->Draw();

  can->Update();
  pad2->cd();

  for(int l = 0; l< h6->GetNbinsX(); l++) {
   h7->SetBinContent(l+1, h6->GetBinContent(l+1)/h->GetBinContent(l+1));
    }

  // h4->SetLineColor(kPink+9);
    h->SetLineColor(kBlack);

    // h7->GetXaxis()->SetTitle("#Delta m[GeV/c^{2}]");
    h7->GetXaxis()->SetTitle("#gamma");
  
    h7->GetXaxis()->SetLabelSize(0.09);
    h7->GetXaxis()->SetTitleSize(0.10);
    h7->GetXaxis()->SetTickLength(0.08);
    h7->GetXaxis()->SetTitleOffset(1.163);
    h7->GetXaxis()->SetTitleFont(42);
    h7->GetYaxis()->SetTitle("Data/MC");
    h7->GetYaxis()->SetLabelSize(0.08);
    h7->GetYaxis()->SetTitleSize(0.09);
    h7->GetYaxis()->SetTitleOffset(0.7);
    h7->GetYaxis()->SetNdivisions(404,kTRUE);
    h7->GetXaxis()->CenterTitle();
    h7->GetYaxis()->CenterTitle();
    h7->SetMarkerStyle(20);
    h7->SetMarkerSize(0.8);
    h7->SetStats(false);
    h7->SetMaximum(1.5);
    h7->SetMinimum(0.5);
    h7->Draw();

    TLine *line = new TLine();
    line->SetLineStyle(2);
    line->SetLineWidth(1);
    line->SetLineColor(kRed);
    line->DrawLine(h7->GetXaxis()->GetXmin(), 1  , h7->GetXaxis()->GetXmax(), 1  );
}
  

        